define([
    "jquery",
    "Magento_Ui/js/modal/modal",
    "jquery/ui",
    "mage/cookies",
    'mage/utils/wrapper'
], function ($, modal) {
    "use strict";

    //creating jquery widget
    $.widget('filoblu.modal_privacy_policy', {
        _create: function () {

            var that = this,
                config = this.options,
                userAccepted = false,
                objCookieData;

            this._super();
            
            var popupOptions = {
                type: 'popup',
                responsive: true,
                modalClass: 'privacyPolicyModal',
                innerScroll: false,
                title: false,
                buttons: false,
                closed: function () {
                var toDay = new Date();//for getting todays date.
                toDay.setTime(toDay.getTime());
                var expaireDate = new Date(toDay.getTime() + parseInt(config.cookieLifetime));
                var stringCookieData = JSON.stringify({privacyVersion: config.privacyStoreVersion , hasAccepted: userAccepted});
                $.mage.cookies.set(config.cookieName, stringCookieData, {"expires": expaireDate});
                }
            };

            if($.mage.cookies.get(config.cookieName)){
                var objCookieData = JSON.parse($.mage.cookies.get(config.cookieName));
            }
                    
            if(!$.mage.cookies.get(config.cookieName) || ( $.mage.cookies.get(config.cookieName) && objCookieData.privacyVersion < config.privacyStoreVersion)){
                $.ajax({
                    showLoader: false,
                    cache: false,
                    url: '/filobluprivacypolicy/index/getdata',
                    type: "POST",
                    dataType: 'json'
                }).done(function (data) {
                    if(data){
                        that.openModalOverlayModal(config.popupId);
                    }
                });
            }

            var popup = modal(popupOptions, $(config.popupId));
            $(popup).css("display", "block");

            $('.button-wrapper .action.primary' , $(config.popupId)).on('click' , function (e){
                if($('.field #privacy_policy:checked' , $(config.popupId)).length ){
                    e.preventDefault();
                    e.stopPropagation();
                    $.ajax({
                        showLoader: true,
                        cache: false,
                        url: '/filobluprivacypolicy/index/setdata',  
                        type: "POST",
                        dataType: 'json'
                    }).done(function (data) {
                        userAccepted = true;
                        that.closeModalOverlayModal(config.popupId);
                    });
                }
            });
        },

        openModalOverlayModal: function(popupIdentifier){
            $(popupIdentifier).modal('openModal');
        },
        closeModalOverlayModal: function(popupIdentifier){
            $(popupIdentifier).modal('closeModal');
        }
    });

    return $.filoblu.modal_privacy_policy;
});
